import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.geom.*;

public class Doughnut extends MazeObject {
    private int neighborsDoughnut;

    public Doughnut() {
	this(0,0);
	neighborsDoughnut = -1;
    }

    public Doughnut(int nd) {
	this(0,0);
	neighborsDoughnut = nd;
	if (nd >= 0) {
	    po.special = nd;
	    this.imageFileName = "OrangeDonut.gif";
	}
    }

    public Doughnut(int x, int y) {
	super(x,y);
	po.type = PerceptObject.DOUGHNUT;
	this.imageFileName = "Donut.gif";
    }

    public int neighborsDoughnut() {
	return neighborsDoughnut;
    }

    public void setNeighborsDoughnut(int nd) {
	neighborsDoughnut = nd;
    }

    public int nextMove() {
	// moves 10% of the time, in a random direction
	if (GamePlayer.nextFloat() < 0.1)
	    return GamePlayer.nextInt(4);
	else
	    return -1;
    }
}
