import java.util.*;

public class LimitList extends Vector {
    int limit;
    Comparator c;
    public LimitList(int limit, Comparator c) {
	super();
	this.limit = limit;
	this.c = c;
    }
    public int findAddLocation(Object obj) throws Exception {
	// this could be made to run in log n time
	int res=this.size();
	if (c == null) {
	    // there is a problem!
	    throw new Exception("Comparator not set in LimitList!\n");
	}

	for (int i=0;i<this.size();i++) {
	    if (c.compare(this.get(i), obj) <  0) {  // if item i < obj, then put obj here
		res = i;
		break;
	    }
	}
	//	System.out.println("returing " + res + " in fAL with Obj = " + obj);
	return res;
    }

    /** returns the index where the object would be added if it 
	is less than the limit, and -1 otherwise */
    public int  testRank(Object item) throws Exception {
	int loc = findAddLocation(item);
	if (loc < limit) 
	    return loc;
	else 
	    return -1;
    }


    public boolean testAdd(Object item) throws Exception {
	int loc = findAddLocation(item);
	if (loc < limit) 
	    return true;
	else 
	    return false;
    }

    public boolean limitAdd(Object item) throws Exception {
	// adds to the list only if it fits within the limit.
	// returns true when the item is added.
	boolean res = false;
	int loc = findAddLocation(item);
	if (loc < limit) {
	    insertElementAt(item, loc);
	    res = true;
	}
	// now, must trim to limit!
	while (size() > limit) 
	    remove(limit);
	return res;
    }

}
