import java.util.*;

/** A simple class that holds the x and y locations of an object as
    well as the previous x and y locations, as well as a "special"
    integer field that indicates something different for different
    objects.  For cops, it indicates how long the cop has been eating
    (-1 = not eating).  For other players, it indicates how long
    they've been held (-1 = not held).  For doughnuts, it indicates
    the id of the team which dropped the doughnut (-1 = not dropped by
    a team) */

public class PerceptObject {
    static final int PLAYER   = 0;
    static final int DOUGHNUT = 1;
    static final int COP      = 2;
    static final int REDBULL  = 3;
    static final int JAY      = 4;
    public int x, y;
    public int lastx, lasty;
    public int special;
    public int type;
    public PerceptObject() {
	x=y=lastx=lasty=-1;
	special = -1;
    }
    public void set(int x, int y) {
	if (x < 0)
	    this.lastx = x;
	else 
	    this.lastx = this.x;
	if (y < 0)
	    this.lasty = y;
	else 
	    this.lasty = this.y;
	this.x = x;
	this.y = y;
    }
    
}
