import java.util.*;

/* This class is called by the GameSimulator class to set up the game.
   It allows you to test different actors that you write against each
   other by changing the number of players, and returning the desired
   actor for each player.  You can also choose an image and name for
   each player.  By default, the game runs with 16 players, all using
   the included ExampleActor.  The image for each player is a blue
   number, and the name is simply that number. */
class PlayerInitializer {
    PlayerInitializer() {}

    /* returns the number of players that should play in this game */
    public int getNumPlayers() { return 16; }

    /* returns an actor for every id */
    public PlayerActor getActor(PlayerInterface pi, int id) {
	return new ExampleActor(pi);
    }
    
    /* returns an image file name for every id */
    public String getImageFileName(int id) {
	return "p" + Integer.toString(id+1) + ".gif";
    }

    /* returns a name for every id */
    public String getName(int id) {
	return "Player " + Integer.toString(id+1);
    }
}
	
