import java.util.*;

/**   The abstract Simulator class. 
 * <br> The video game will use a subclassed simulator, 
 * <br> i.e. GameSimulator, whereas the trace simulator will 
 * <br> use TraceSimulator
 */
public abstract class Simulator {
    /** simple empty constructor */
    public Simulator() {}
    
    /** Sets the initial state of the simulation*/
    public abstract void setInitialState();

    /** Can a further step be simulated?  Or is the simulation over? */
    public abstract boolean CanDoAnotherStep();

    /** This is the command telling the simulator to take a step. */
    public abstract void Step();    
}
